// Enable debug prints to serial monitor
//#define MY_DEBUG

#define MY_NODE_ID 98

// Enable serial gateway
#define MY_GATEWAY_SERIAL

// Define a lower baud rate for Arduino's running on 8 MHz (Arduino Pro Mini 3.3V & SenseBender)
#if F_CPU == 8000000L
#define MY_BAUD_RATE 38400
#endif

// Enable inclusion mode
#define MY_INCLUSION_MODE_FEATURE
// Enable Inclusion mode button on gateway
#define MY_INCLUSION_BUTTON_FEATURE

// Set inclusion mode duration (in seconds)
#define MY_INCLUSION_MODE_DURATION 60 
// Digital pin used for inclusion mode button
#define MY_INCLUSION_MODE_BUTTON_PIN A1

// Uncomment to override default HW configurations
//#define MY_DEFAULT_ERR_LED_PIN 4 // Error led pin
//#define MY_DEFAULT_RX_LED_PIN 6 // Receive led pin
//#define MY_DEFAULT_TX_LED_PIN 5 // the PCB, on board LED

#include <SPI.h>
#include <MySensors.h> 
#include <Bounce2.h>

// Enable repeater functionality for this node
#define MY_REPEATER_FEATURE

//Ogolna definacja jakim stanem wlaczany jest przekaznik w tym przypadku zalaczany jest 1
#define RELAY_ON 1 // GPIO value to write to turn on attached relay
#define RELAY_OFF 0 // GPIO value to write to turn off attached relay

//Definicja włączników światła dla zespołu przekaźników (liczone od prawej od samego dołu)
//Sposób opisywanie buttonow B-button, P0,1,2-poziom_budynku, Miejsce, sw-światło, 1,2 lewe_prawe,_PORT_A11 (nr portu)
//Sposób opisywania relay R-Relay, P0,1,2-poziom_budynku, Miejsce, sw-światło, 1,2 lewe_prawe,_PORT_A11 (nr portu)


//UWAGA UNIKAMY PIN 0,1, 20,21
//Uwaga STATUS ---- 0=cover is down, 1=cover is up
// czyli np C_R_P1_GOSCINNY_ROL1_UP = 0 rol down


// ************************** ROLETY *******************************

//P1_GOSCINNY_ROL1
#define ID_P1_GOSCINNY_ROL1 0 //Id przekąźnika oraz pamięc położenia rolety 0% (close) - 100% (up) zapisywana w pamięci stałej.
#define B_P1_GOSCINNY_ROL1_DOWN A2
#define R_P1_GOSCINNY_ROL1_DOWN 2
Bounce BO_B_P1_GOSCINNY_ROL1_DOWN = Bounce();
#define B_P1_GOSCINNY_ROL1_UP A3
#define R_P1_GOSCINNY_ROL1_UP 3
Bounce BO_B_P1_GOSCINNY_ROL1_UP = Bounce();
unsigned short STATUS_P1_GOSCINNY_ROL1 = 0; //0-Stop, 1-Down, 2-Up
unsigned long FULL_TIME_P1_GOSCINNY_ROL1 = 35000; //czas do zamkniecia/otwarcia całkowitego rolety - ms
unsigned long PREV_TIME_P1_GOSCINNY_ROL1;
unsigned long TEMP_TIME_P1_GOSCINNY_ROL1 = 0;
unsigned long OFFSET_TIME_P1_GOSCINNY_ROL1 = 2000; //ms offset

//P1_OLAFA_ROL1
#define ID_P1_OLAFA_ROL1 1 //Id przekąźnika oraz pamięc położenia rolety 0% (close) - 100% (up) zapisywana w pamięci stałej.
#define B_P1_OLAFA_ROL1_DOWN A4
#define R_P1_OLAFA_ROL1_DOWN 4
Bounce BO_B_P1_OLAFA_ROL1_DOWN = Bounce();
#define B_P1_OLAFA_ROL1_UP A5
#define R_P1_OLAFA_ROL1_UP 5
Bounce BO_B_P1_OLAFA_ROL1_UP = Bounce();
unsigned short STATUS_P1_OLAFA_ROL1 = 0; //0-Stop, 1-Down, 2-Up
unsigned long FULL_TIME_P1_OLAFA_ROL1 = 35000; //czas do zamkniecia/otwarcia całkowitego rolety - ms
unsigned long PREV_TIME_P1_OLAFA_ROL1;
unsigned long TEMP_TIME_P1_OLAFA_ROL1 = 0;
unsigned long OFFSET_TIME_P1_OLAFA_ROL1 = 2000; //ms offset

//P1_SYPIALNIA_ROL1
#define ID_P1_SYPIALNIA_ROL1 2 //Id przekąźnika oraz pamięc położenia rolety 0% (close) - 100% (up) zapisywana w pamięci stałej.
#define B_P1_SYPIALNIA_ROL1_DOWN A6
#define R_P1_SYPIALNIA_ROL1_DOWN 6
Bounce BO_B_P1_SYPIALNIA_ROL1_DOWN = Bounce();
#define B_P1_SYPIALNIA_ROL1_UP A7
#define R_P1_SYPIALNIA_ROL1_UP 7
Bounce BO_B_P1_SYPIALNIA_ROL1_UP = Bounce();
unsigned short STATUS_P1_SYPIALNIA_ROL1 = 0; //0-Stop, 1-Down, 2-Up
unsigned long FULL_TIME_P1_SYPIALNIA_ROL1 = 35000; //czas do zamkniecia/otwarcia całkowitego rolety - ms
unsigned long PREV_TIME_P1_SYPIALNIA_ROL1;
unsigned long TEMP_TIME_P1_SYPIALNIA_ROL1 = 0;
unsigned long OFFSET_TIME_P1_SYPIALNIA_ROL1 = 2000; //ms offset

//P1_SYPIALNIA_ROL2
#define ID_P1_SYPIALNIA_ROL2 3 //Id przekąźnika oraz pamięc położenia rolety 0% (close) - 100% (up) zapisywana w pamięci stałej.
#define B_P1_SYPIALNIA_ROL2_DOWN A8
#define R_P1_SYPIALNIA_ROL2_DOWN 8
Bounce BO_B_P1_SYPIALNIA_ROL2_DOWN = Bounce();
#define B_P1_SYPIALNIA_ROL2_UP A9
#define R_P1_SYPIALNIA_ROL2_UP 9
Bounce BO_B_P1_SYPIALNIA_ROL2_UP = Bounce();
unsigned short STATUS_P1_SYPIALNIA_ROL2 = 0; //0-Stop, 1-Down, 2-Up
unsigned long FULL_TIME_P1_SYPIALNIA_ROL2 = 35000; //czas do zamkniecia/otwarcia całkowitego rolety - ms
unsigned long PREV_TIME_P1_SYPIALNIA_ROL2;
unsigned long TEMP_TIME_P1_SYPIALNIA_ROL2 = 0;
unsigned long OFFSET_TIME_P1_SYPIALNIA_ROL2 = 2000; //ms offset

//P0_SALON_ROL1
#define ID_P0_SALON_ROL1 4 //Id przekąźnika oraz pamięc położenia rolety 0% (close) - 100% (up) zapisywana w pamięci stałej.
#define B_P0_SALON_ROL1_DOWN A10
#define R_P0_SALON_ROL1_DOWN 10
Bounce BO_B_P0_SALON_ROL1_DOWN = Bounce();
#define B_P0_SALON_ROL1_UP A11
#define R_P0_SALON_ROL1_UP 11
Bounce BO_B_P0_SALON_ROL1_UP = Bounce();
unsigned short STATUS_P0_SALON_ROL1 = 0; //0-Stop, 1-Down, 2-Up
unsigned long FULL_TIME_P0_SALON_ROL1 = 35000; //czas do zamkniecia/otwarcia całkowitego rolety - ms
unsigned long PREV_TIME_P0_SALON_ROL1;
unsigned long TEMP_TIME_P0_SALON_ROL1 = 0;
unsigned long OFFSET_TIME_P0_SALON_ROL1 = 2000; //ms offset

//P0_SALON_ROL2
#define ID_P0_SALON_ROL2 5 //Id przekąźnika oraz pamięc położenia rolety 0% (close) - 100% (up) zapisywana w pamięci stałej.
#define B_P0_SALON_ROL2_DOWN A12
#define R_P0_SALON_ROL2_DOWN 12
Bounce BO_B_P0_SALON_ROL2_DOWN = Bounce();
#define B_P0_SALON_ROL2_UP A13
#define R_P0_SALON_ROL2_UP 13
Bounce BO_B_P0_SALON_ROL2_UP = Bounce();
unsigned short STATUS_P0_SALON_ROL2 = 0; //0-Stop, 1-Down, 2-Up
unsigned long FULL_TIME_P0_SALON_ROL2 = 35000; //czas do zamkniecia/otwarcia całkowitego rolety - ms
unsigned long PREV_TIME_P0_SALON_ROL2;
unsigned long TEMP_TIME_P0_SALON_ROL2 = 0;
unsigned long OFFSET_TIME_P0_SALON_ROL2 = 2000; //ms offset

//*************************** SCHODOWE ************************************

// Wiatrołap
#define ID_SCH_P0_WIATROLAP_1_1 6
#define ID_SCH_P0_WIATROLAP_1_2 7
#define B_SCH_P0_WIATROLAP_1_1 22
#define B_SCH_P0_WIATROLAP_1_2 24
#define R_SCH_P0_WIATROLAP 23
Bounce BO_SCH_P0_WIATROLAP_1_1 = Bounce();
Bounce BO_SCH_P0_WIATROLAP_1_2 = Bounce();

// Korytarz parter
#define ID_SCH_P0_KORYTARZ_1_1 8
#define ID_SCH_P0_KORYTARZ_1_2 9
#define B_SCH_P0_KORYTARZ_1_1 26
#define B_SCH_P0_KORYTARZ_1_2 28
#define R_SCH_P0_KORYTARZ 27
Bounce BO_SCH_P0_KORYTARZ_1_1 = Bounce();
Bounce BO_SCH_P0_KORYTARZ_1_2 = Bounce();

// Schody
#define ID_SCH_SCHODY_1_1 10
#define ID_SCH_SCHODY_1_2 11
#define B_SCH_SCHODY_1_1 30
#define B_SCH_SCHODY_1_2 32
#define R_SCH_SCHODY 31
Bounce BO_SCH_SCHODY_1_1 = Bounce();
Bounce BO_SCH_SCHODY_1_2 = Bounce();

// Korytarz piętro
#define ID_SCH_P1_KORYTARZ_1_1 12
#define ID_SCH_P1_KORYTARZ_1_2 13
#define B_SCH_P1_KORYTARZ_1_1 34
#define B_SCH_P1_KORYTARZ_1_2 36
#define R_SCH_P1_KORYTARZ 35
Bounce BO_SCH_P1_KORYTARZ_1_1 = Bounce();
Bounce BO_SCH_P1_KORYTARZ_1_2 = Bounce();

// Balkon Olafa + gościnny
#define ID_SCH_P1_BALKON_1_1 14
#define ID_SCH_P1_BALKON_1_2 15
#define B_SCH_P1_BALKON_1_1 38
#define B_SCH_P1_BALKON_1_2 40
#define R_SCH_P1_BALKON 39
Bounce BO_SCH_P1_BALKON_1_1 = Bounce();
Bounce BO_SCH_P1_BALKON_1_2 = Bounce();

//********************************* Dzwonkowe ****************************

// Dzwonek
#define ID_DZW_P0_DZWONEK 16
#define B_DZW_P0_DZWONEK 42
#define R_DZW_P0_DZWONEK 43
Bounce BO_DZW_P0_DZWONEK = Bounce();

//Wszelkie połączenia z urządzeniami zewnętrzymi, przed uruchomieniem mysensors
void before() 
{

}

//Prezentacja przekaźników dla domoticza
void presentation() 
{ 
    sendSketchInfo("ARDUINO - rolety + schodowe", "1.0");
    
    // Rolety
    present(ID_P1_GOSCINNY_ROL1, S_COVER, "P1_GOSCINNY_ROL1");
    present(ID_P1_OLAFA_ROL1, S_COVER, "P1_OLAFA_ROL1");
    present(ID_P1_SYPIALNIA_ROL1, S_COVER, "P1_SYPIALNIA_ROL1");
    present(ID_P1_SYPIALNIA_ROL2, S_COVER, "P1_SYPIALNIA_ROL2");
    present(ID_P0_SALON_ROL1, S_COVER, "P0_SALON_ROL1");
    present(ID_P0_SALON_ROL2, S_COVER, "P0_SALON_ROL2");
    // Schodowe
    present(ID_SCH_P0_WIATROLAP_1_1, S_LIGHT, "SCH_P0_WIATROLAP");
    present(ID_SCH_P0_KORYTARZ_1_1, S_LIGHT, "SCH_P0_KORYTARZ");
    present(ID_SCH_SCHODY_1_1, S_LIGHT, "SCH_SCHODY");
    present(ID_SCH_P1_KORYTARZ_1_1, S_LIGHT, "SCH_P1_KORYTARZ");
    present(ID_SCH_P1_BALKON_1_1, S_LIGHT, "SCH_P1_BALKON");
    // Dzwonkowe
    present(ID_DZW_P0_DZWONEK, S_LIGHT, "DZW_P0_DZWONEK");
}

void setup() 
{
    delay(1000);
    //************************* Rolety *******************************
    //GOŚCINNY ----
    //Ustawianie button P1_GOSCINNY_ROL1_
    //*** DOWN ***
    pinMode(R_P1_GOSCINNY_ROL1_DOWN,OUTPUT);
    pinMode(B_P1_GOSCINNY_ROL1_DOWN, INPUT_PULLUP);
    BO_B_P1_GOSCINNY_ROL1_DOWN.attach(B_P1_GOSCINNY_ROL1_DOWN);
    BO_B_P1_GOSCINNY_ROL1_DOWN.interval(5);
    //*** UP ***
    pinMode(R_P1_GOSCINNY_ROL1_UP,OUTPUT);
    pinMode(B_P1_GOSCINNY_ROL1_UP, INPUT_PULLUP);
    BO_B_P1_GOSCINNY_ROL1_UP.attach(B_P1_GOSCINNY_ROL1_UP);
    BO_B_P1_GOSCINNY_ROL1_UP.interval(5);
    //Zerowanie pinów wyj. 
    digitalWrite(R_P1_GOSCINNY_ROL1_DOWN, RELAY_OFF);
    digitalWrite(R_P1_GOSCINNY_ROL1_UP, RELAY_OFF);

    //OLAFA ----
    //Ustawianie button P1_OLAFA_ROL1_
    //*** DOWN ***
    pinMode(R_P1_OLAFA_ROL1_DOWN,OUTPUT);
    pinMode(B_P1_OLAFA_ROL1_DOWN, INPUT_PULLUP);
    BO_B_P1_OLAFA_ROL1_DOWN.attach(B_P1_OLAFA_ROL1_DOWN);
    BO_B_P1_OLAFA_ROL1_DOWN.interval(5);
    //*** UP ***
    pinMode(R_P1_OLAFA_ROL1_UP,OUTPUT);
    pinMode(B_P1_OLAFA_ROL1_UP, INPUT_PULLUP);
    BO_B_P1_OLAFA_ROL1_UP.attach(B_P1_OLAFA_ROL1_UP);
    BO_B_P1_OLAFA_ROL1_UP.interval(5);
    //Zerowanie pinów wyj. 
    digitalWrite(R_P1_OLAFA_ROL1_DOWN, RELAY_OFF);
    digitalWrite(R_P1_OLAFA_ROL1_UP, RELAY_OFF);

    //SYPIALNIA ROL1 ----
    //Ustawianie button P1_SYPIALNIA_ROL1_
    //*** DOWN ***
    pinMode(R_P1_SYPIALNIA_ROL1_DOWN,OUTPUT);
    pinMode(B_P1_SYPIALNIA_ROL1_DOWN, INPUT_PULLUP);
    BO_B_P1_SYPIALNIA_ROL1_DOWN.attach(B_P1_SYPIALNIA_ROL1_DOWN);
    BO_B_P1_SYPIALNIA_ROL1_DOWN.interval(5);
    //*** UP ***
    pinMode(R_P1_SYPIALNIA_ROL1_UP,OUTPUT);
    pinMode(B_P1_SYPIALNIA_ROL1_UP, INPUT_PULLUP);
    BO_B_P1_SYPIALNIA_ROL1_UP.attach(B_P1_SYPIALNIA_ROL1_UP);
    BO_B_P1_SYPIALNIA_ROL1_UP.interval(5);
    //Zerowanie pinów wyj. 
    digitalWrite(R_P1_SYPIALNIA_ROL1_DOWN, RELAY_OFF);
    digitalWrite(R_P1_SYPIALNIA_ROL1_UP, RELAY_OFF);

    //SYPIALNIA ROL2 ----
    //Ustawianie button P1_SYPIALNIA_ROL2_
    //*** DOWN ***
    pinMode(R_P1_SYPIALNIA_ROL2_DOWN,OUTPUT);
    pinMode(B_P1_SYPIALNIA_ROL2_DOWN, INPUT_PULLUP);
    BO_B_P1_SYPIALNIA_ROL2_DOWN.attach(B_P1_SYPIALNIA_ROL2_DOWN);
    BO_B_P1_SYPIALNIA_ROL2_DOWN.interval(5);
    //*** UP ***
    pinMode(R_P1_SYPIALNIA_ROL2_UP,OUTPUT);
    pinMode(B_P1_SYPIALNIA_ROL2_UP, INPUT_PULLUP);
    BO_B_P1_SYPIALNIA_ROL2_UP.attach(B_P1_SYPIALNIA_ROL2_UP);
    BO_B_P1_SYPIALNIA_ROL2_UP.interval(5);
    //Zerowanie pinów wyj. 
    digitalWrite(R_P1_SYPIALNIA_ROL2_DOWN, RELAY_OFF);
    digitalWrite(R_P1_SYPIALNIA_ROL2_UP, RELAY_OFF);

    //SALON ROL1 ----
    //Ustawianie button P1_SYPIALNIA_ROL1_
    //*** DOWN ***
    pinMode(R_P0_SALON_ROL1_DOWN,OUTPUT);
    pinMode(B_P0_SALON_ROL1_DOWN, INPUT_PULLUP);
    BO_B_P0_SALON_ROL1_DOWN.attach(B_P0_SALON_ROL1_DOWN);
    BO_B_P0_SALON_ROL1_DOWN.interval(5);
    //*** UP ***
    pinMode(R_P0_SALON_ROL1_UP,OUTPUT);
    pinMode(B_P0_SALON_ROL1_UP, INPUT_PULLUP);
    BO_B_P0_SALON_ROL1_UP.attach(B_P0_SALON_ROL1_UP);
    BO_B_P0_SALON_ROL1_UP.interval(5);
    //Zerowanie pinów wyj. 
    digitalWrite(R_P0_SALON_ROL1_DOWN, RELAY_OFF);
    digitalWrite(R_P0_SALON_ROL1_UP, RELAY_OFF);

    //SALON ROL2 ----
    //Ustawianie button P0_SALON_ROL2_
    //*** DOWN ***
    pinMode(R_P0_SALON_ROL2_DOWN,OUTPUT);
    pinMode(B_P0_SALON_ROL2_DOWN, INPUT_PULLUP);
    BO_B_P0_SALON_ROL2_DOWN.attach(B_P0_SALON_ROL2_DOWN);
    BO_B_P0_SALON_ROL2_DOWN.interval(5);
    //*** UP ***
    pinMode(R_P0_SALON_ROL2_UP,OUTPUT);
    pinMode(B_P0_SALON_ROL2_UP, INPUT_PULLUP);
    BO_B_P0_SALON_ROL2_UP.attach(B_P0_SALON_ROL2_UP);
    BO_B_P0_SALON_ROL2_UP.interval(5);
    //Zerowanie pinów wyj. 
    digitalWrite(R_P0_SALON_ROL2_DOWN, RELAY_OFF);
    digitalWrite(R_P0_SALON_ROL2_UP, RELAY_OFF);

   // ********************** SCHODOWE *****************
    // Wiatrołap
    // #1_1
    pinMode(B_SCH_P0_WIATROLAP_1_1, INPUT_PULLUP);
    BO_SCH_P0_WIATROLAP_1_1.attach(B_SCH_P0_WIATROLAP_1_1);
    BO_SCH_P0_WIATROLAP_1_1.interval(5);

    // #1_2
    pinMode(B_SCH_P0_WIATROLAP_1_2, INPUT_PULLUP);
    BO_SCH_P0_WIATROLAP_1_2.attach(B_SCH_P0_WIATROLAP_1_2);
    BO_SCH_P0_WIATROLAP_1_2.interval(5); 

    // Korytarz parter
    // #1_1
    pinMode(B_SCH_P0_KORYTARZ_1_1, INPUT_PULLUP);
    BO_SCH_P0_KORYTARZ_1_1.attach(B_SCH_P0_KORYTARZ_1_1);
    BO_SCH_P0_KORYTARZ_1_1.interval(5);

    // #1_2
    pinMode(B_SCH_P0_KORYTARZ_1_2, INPUT_PULLUP);
    BO_SCH_P0_KORYTARZ_1_2.attach(B_SCH_P0_KORYTARZ_1_2);
    BO_SCH_P0_KORYTARZ_1_2.interval(5); 

    // Schody
    // #1_1
    pinMode(B_SCH_SCHODY_1_1, INPUT_PULLUP);
    BO_SCH_SCHODY_1_1.attach(B_SCH_SCHODY_1_1);
    BO_SCH_SCHODY_1_1.interval(5);

    // #1_2
    pinMode(B_SCH_SCHODY_1_2, INPUT_PULLUP);
    BO_SCH_SCHODY_1_2.attach(B_SCH_SCHODY_1_2);
    BO_SCH_SCHODY_1_2.interval(5); 

    // Korytarz pietro
    // #1_1
    pinMode(B_SCH_P1_KORYTARZ_1_1, INPUT_PULLUP);
    BO_SCH_P1_KORYTARZ_1_1.attach(B_SCH_P1_KORYTARZ_1_1);
    BO_SCH_P1_KORYTARZ_1_1.interval(5);

    // #1_2
    pinMode(B_SCH_P1_KORYTARZ_1_2, INPUT_PULLUP);
    BO_SCH_P1_KORYTARZ_1_2.attach(B_SCH_P1_KORYTARZ_1_2);
    BO_SCH_P1_KORYTARZ_1_2.interval(5); 

    // Balkon Olafa + gościnny
    // #1_1
    pinMode(B_SCH_P1_BALKON_1_1, INPUT_PULLUP);
    BO_SCH_P1_BALKON_1_1.attach(B_SCH_P1_BALKON_1_1);
    BO_SCH_P1_BALKON_1_1.interval(5);

    // #1_2
    pinMode(B_SCH_P1_BALKON_1_2, INPUT_PULLUP);
    BO_SCH_P1_BALKON_1_2.attach(B_SCH_P1_BALKON_1_2);
    BO_SCH_P1_BALKON_1_2.interval(5); 


    //Zerowanie pinów wyj. 
    digitalWrite(R_SCH_P0_WIATROLAP, RELAY_OFF);
    digitalWrite(R_SCH_P0_KORYTARZ, RELAY_OFF);
    digitalWrite(R_SCH_SCHODY, RELAY_OFF);
    digitalWrite(R_SCH_P1_KORYTARZ, RELAY_OFF);
    digitalWrite(R_SCH_P1_BALKON, RELAY_OFF);

    //********************************* Dzwonkowe ****************************
    // Dzwonek
    pinMode(B_DZW_P0_DZWONEK, INPUT_PULLUP);
    BO_DZW_P0_DZWONEK.attach(B_DZW_P0_DZWONEK);
    BO_DZW_P0_DZWONEK.interval(5);

    //Zerowanie pinów wyj. 
    digitalWrite(R_DZW_P0_DZWONEK, RELAY_OFF);

}

//definicja wiadomości - przekazywane dla domoticza
//GOŚCINNY ---
MyMessage msg_P1_GOSCINNY_ROL1_UP(ID_P1_GOSCINNY_ROL1, V_UP);
MyMessage msg_P1_GOSCINNY_ROL1_DOWN(ID_P1_GOSCINNY_ROL1, V_DOWN);
MyMessage msg_P1_GOSCINNY_ROL1_STOP(ID_P1_GOSCINNY_ROL1, V_STOP);
MyMessage msg_P1_GOSCINNY_ROL1_PERC(ID_P1_GOSCINNY_ROL1, V_PERCENTAGE);

//OLAFA ---
MyMessage msg_P1_OLAFA_ROL1_UP(ID_P1_OLAFA_ROL1, V_UP);
MyMessage msg_P1_OLAFA_ROL1_DOWN(ID_P1_OLAFA_ROL1, V_DOWN);
MyMessage msg_P1_OLAFA_ROL1_STOP(ID_P1_OLAFA_ROL1, V_STOP);
MyMessage msg_P1_OLAFA_ROL1_PERC(ID_P1_OLAFA_ROL1, V_PERCENTAGE);

//SYPIALNIA ROL1---
MyMessage msg_P1_SYPIALNIA_ROL1_UP(ID_P1_SYPIALNIA_ROL1, V_UP);
MyMessage msg_P1_SYPIALNIA_ROL1_DOWN(ID_P1_SYPIALNIA_ROL1, V_DOWN);
MyMessage msg_P1_SYPIALNIA_ROL1_STOP(ID_P1_SYPIALNIA_ROL1, V_STOP);
MyMessage msg_P1_SYPIALNIA_ROL1_PERC(ID_P1_SYPIALNIA_ROL1, V_PERCENTAGE);

//SYPIALNIA ROL2 ---
MyMessage msg_P1_SYPIALNIA_ROL2_UP(ID_P1_SYPIALNIA_ROL2, V_UP);
MyMessage msg_P1_SYPIALNIA_ROL2_DOWN(ID_P1_SYPIALNIA_ROL2, V_DOWN);
MyMessage msg_P1_SYPIALNIA_ROL2_STOP(ID_P1_SYPIALNIA_ROL2, V_STOP);
MyMessage msg_P1_SYPIALNIA_ROL2_PERC(ID_P1_SYPIALNIA_ROL2, V_PERCENTAGE);

//SYPIALNIA ROL1---
MyMessage msg_P0_SALON_ROL1_UP(ID_P0_SALON_ROL1, V_UP);
MyMessage msg_P0_SALON_ROL1_DOWN(ID_P0_SALON_ROL1, V_DOWN);
MyMessage msg_P0_SALON_ROL1_STOP(ID_P0_SALON_ROL1, V_STOP);
MyMessage msg_P0_SALON_ROL1_PERC(ID_P0_SALON_ROL1, V_PERCENTAGE);

//SALON ROL2 ---
MyMessage msg_P0_SALON_ROL2_UP(ID_P0_SALON_ROL2, V_UP);
MyMessage msg_P0_SALON_ROL2_DOWN(ID_P0_SALON_ROL2, V_DOWN);
MyMessage msg_P0_SALON_ROL2_STOP(ID_P0_SALON_ROL2, V_STOP);
MyMessage msg_P0_SALON_ROL2_PERC(ID_P0_SALON_ROL2, V_PERCENTAGE);

//***************** SCHODOWE ***********************
MyMessage msg_SCH_P0_WIATROLAP_1_1(ID_SCH_P0_WIATROLAP_1_1, V_LIGHT);
MyMessage msg_SCH_P0_KORYTARZ_1_1(ID_SCH_P0_KORYTARZ_1_1, V_LIGHT);
MyMessage msg_SCH_SCHODY_1_1(ID_SCH_SCHODY_1_1, V_LIGHT);
MyMessage msg_SCH_P1_KORYTARZ_1_1(ID_SCH_P1_KORYTARZ_1_1, V_LIGHT);
MyMessage msg_SCH_P1_BALKON_1_1(ID_SCH_P1_BALKON_1_1, V_LIGHT);

//***************** DZWONKOWE ***********************
MyMessage msg_DZW_P0_DZWONEK(ID_DZW_P0_DZWONEK, V_LIGHT);


void run_once()
{
//GOŚCINNY  
send(msg_P1_GOSCINNY_ROL1_UP.set(1)); 
send(msg_P1_GOSCINNY_ROL1_DOWN.set(1));
send(msg_P1_GOSCINNY_ROL1_STOP.set(1));
send(msg_P1_GOSCINNY_ROL1_PERC.set(loadState(ID_P1_GOSCINNY_ROL1)));

//OLAFA
send(msg_P1_OLAFA_ROL1_UP.set(1)); 
send(msg_P1_OLAFA_ROL1_DOWN.set(1));
send(msg_P1_OLAFA_ROL1_STOP.set(1));
send(msg_P1_OLAFA_ROL1_PERC.set(loadState(ID_P1_OLAFA_ROL1)));

//SYPIALNIA ROL1
send(msg_P1_SYPIALNIA_ROL1_UP.set(1)); 
send(msg_P1_SYPIALNIA_ROL1_DOWN.set(1));
send(msg_P1_SYPIALNIA_ROL1_STOP.set(1));
send(msg_P1_SYPIALNIA_ROL1_PERC.set(loadState(ID_P1_SYPIALNIA_ROL1)));

//SYPIALNIA ROL2
send(msg_P1_SYPIALNIA_ROL2_UP.set(1)); 
send(msg_P1_SYPIALNIA_ROL2_DOWN.set(1));
send(msg_P1_SYPIALNIA_ROL2_STOP.set(1));
send(msg_P1_SYPIALNIA_ROL2_PERC.set(loadState(ID_P1_SYPIALNIA_ROL2)));

//SALON ROL1
send(msg_P0_SALON_ROL1_UP.set(1)); 
send(msg_P0_SALON_ROL1_DOWN.set(1));
send(msg_P0_SALON_ROL1_STOP.set(1));
send(msg_P0_SALON_ROL1_PERC.set(loadState(ID_P0_SALON_ROL1)));

//SALON ROL2
send(msg_P0_SALON_ROL2_UP.set(1)); 
send(msg_P0_SALON_ROL2_DOWN.set(1));
send(msg_P0_SALON_ROL2_STOP.set(1));
send(msg_P0_SALON_ROL2_PERC.set(loadState(ID_P0_SALON_ROL2)));

// ******************** SCHODOWE **********************
send(msg_SCH_P0_WIATROLAP_1_1.set(0));
send(msg_SCH_P0_KORYTARZ_1_1.set(0));
send(msg_SCH_SCHODY_1_1.set(0));
send(msg_SCH_P1_KORYTARZ_1_1.set(0));
send(msg_SCH_P1_BALKON_1_1.set(0));

// ******************** DZWONKOWE **********************
send(msg_DZW_P0_DZWONEK.set(0));

}

void cover_perc_down_up(unsigned short ID_COVER, unsigned short &STATUS_COVER, unsigned short R_COVER_DOWN, unsigned short R_COVER_UP, MyMessage msg_COVER_DOWN, MyMessage msg_COVER_UP, 
MyMessage msg_COVER_STOP, MyMessage msg_COVER_PERC, unsigned short TARGET_PERC, 
unsigned long FULL_TIME_COVER, unsigned long &PREV_TIME_COVER, unsigned long OFFSET_TIME_COVER, unsigned long &TEMP_TIME_COVER)
{
    //Relay is up or down already
    if(STATUS_COVER != 0)
    {
        time_to_stop(STATUS_COVER, R_COVER_DOWN, R_COVER_UP, msg_COVER_STOP, msg_COVER_PERC, ID_COVER, PREV_TIME_COVER, FULL_TIME_COVER, OFFSET_TIME_COVER, TEMP_TIME_COVER);
    }
    else
    { 
        unsigned short cover_percentage = loadState(ID_COVER);
        
        if(cover_percentage > TARGET_PERC) //DOWN
        { 
            cover_down_up(ID_COVER, true, STATUS_COVER, R_COVER_DOWN, R_COVER_UP, msg_COVER_DOWN, msg_COVER_UP, msg_COVER_STOP, msg_COVER_PERC , FULL_TIME_COVER, PREV_TIME_COVER, OFFSET_TIME_COVER, TEMP_TIME_COVER); 
            TEMP_TIME_COVER = ((cover_percentage - TARGET_PERC)*(FULL_TIME_COVER - OFFSET_TIME_COVER))/100; 
        }

        if(cover_percentage < TARGET_PERC) //UP
        {
            cover_down_up(ID_COVER, false, STATUS_COVER, R_COVER_DOWN, R_COVER_UP, msg_COVER_DOWN, msg_COVER_UP, msg_COVER_STOP, msg_COVER_PERC , FULL_TIME_COVER, PREV_TIME_COVER, OFFSET_TIME_COVER, TEMP_TIME_COVER);
            TEMP_TIME_COVER = ((TARGET_PERC - cover_percentage)*(FULL_TIME_COVER - OFFSET_TIME_COVER))/100; 
        }

        if(cover_percentage == TARGET_PERC) //STOP
        {
            TEMP_TIME_COVER = 0; 
        }

        if(TARGET_PERC == 100 || TARGET_PERC == 0) // Full open or close
        {
            TEMP_TIME_COVER += OFFSET_TIME_COVER; //Dodajemy czas offset dla pewności o całkoitym zamknięciu/otwarciu
        }
    }
}

void time_to_stop(unsigned short &STATUS_COVER, unsigned short R_COVER_DOWN, unsigned short R_COVER_UP, MyMessage msg_COVER_STOP, MyMessage msg_COVER_PERC, unsigned short ID_COVER, unsigned long PREV_TIME_COVER, unsigned long FULL_TIME_COVER, unsigned long OFFSET_TIME_COVER, unsigned long &TEMP_TIME_COVER)
{
    unsigned long current_time = millis();

    //check percent time
    if(STATUS_COVER != 0)
    {
        if(TEMP_TIME_COVER > 0)
        {
            if(current_time - PREV_TIME_COVER > TEMP_TIME_COVER)
            {
                cover_stop(ID_COVER, STATUS_COVER, R_COVER_DOWN, R_COVER_UP, msg_COVER_STOP, msg_COVER_PERC, FULL_TIME_COVER, PREV_TIME_COVER, OFFSET_TIME_COVER, TEMP_TIME_COVER);
            } 
        }
    }

    if(STATUS_COVER == 1) //Cover DOWN
    {
        //check total time
        if(current_time - PREV_TIME_COVER > FULL_TIME_COVER)
        {
            digitalWrite(R_COVER_DOWN, RELAY_OFF);
            digitalWrite(R_COVER_UP, RELAY_OFF);
            saveState(ID_COVER,0); // COVER closed percentage 0 
            send(msg_COVER_PERC.set(loadState(ID_COVER)));
            STATUS_COVER = 0;
            TEMP_TIME_COVER = 0;
        } 
    }

    if(STATUS_COVER == 2) //Cover UP
    {
        if(current_time - PREV_TIME_COVER > FULL_TIME_COVER)
        {
            digitalWrite(R_COVER_DOWN, RELAY_OFF);
            digitalWrite(R_COVER_UP, RELAY_OFF);
            saveState(ID_COVER,100); // COVER open percentage 100 
            send(msg_COVER_PERC.set(loadState(ID_COVER)));
            STATUS_COVER = 0;
            TEMP_TIME_COVER = 0;
        } 
     } 
}

void time_percentage(unsigned long FULL_TIME_COVER, unsigned long OFFSET_TIME_COVER, unsigned long PREV_TIME_COVER, unsigned short ID_COVER, MyMessage msg_COVER_PERC, bool Is_DOWN)
{
    unsigned short temp = ((millis() - PREV_TIME_COVER)*100)/(FULL_TIME_COVER - OFFSET_TIME_COVER);

    if(Is_DOWN == true) //IF cover down
    {
        if(loadState(ID_COVER) < temp)
        {
            saveState(ID_COVER, 0); // Closed
        }
        
        else
        {
            saveState(ID_COVER,(loadState(ID_COVER) - temp));
        }
    }
    
    else //Open
    {
        if(loadState(ID_COVER) + temp >100)
        {
            saveState(ID_COVER, 100); // Closed
        }
        
        else
        {
            saveState(ID_COVER,(loadState(ID_COVER) + temp));
        }
    }
    send(msg_COVER_PERC.set(loadState(ID_COVER)));
}

void cover_stop(unsigned short ID_COVER, unsigned short &STATUS_COVER, unsigned short R_COVER_DOWN, unsigned short R_COVER_UP,MyMessage msg_COVER_STOP, MyMessage msg_COVER_PERC , 
unsigned long FULL_TIME_COVER, unsigned long PREV_TIME_COVER, unsigned long OFFSET_TIME_COVER, unsigned long &TEMP_TIME_COVER)
{
    digitalWrite(R_COVER_UP, RELAY_OFF);
    digitalWrite(R_COVER_DOWN, RELAY_OFF); 
    send(msg_COVER_STOP.set(1)); 

    if(STATUS_COVER == 1) //already down, so percent send
    { 
        time_percentage(FULL_TIME_COVER, OFFSET_TIME_COVER, PREV_TIME_COVER, ID_COVER, msg_COVER_PERC, true); 
    }

    if(STATUS_COVER == 2) //already up, so percent send
    {
        time_percentage(FULL_TIME_COVER, OFFSET_TIME_COVER, PREV_TIME_COVER, ID_COVER, msg_COVER_PERC, false); 
    }

    STATUS_COVER = 0; // STOP
    TEMP_TIME_COVER = 0;
}

void cover_down_up(unsigned short ID_COVER, bool Is_DOWN, unsigned short &STATUS_COVER, unsigned short R_COVER_DOWN, unsigned short R_COVER_UP, MyMessage msg_COVER_DOWN, MyMessage msg_COVER_UP, 
MyMessage msg_COVER_STOP, MyMessage msg_COVER_PERC , unsigned long FULL_TIME_COVER, unsigned long &PREV_TIME_COVER, unsigned long OFFSET_TIME_COVER, unsigned long &TEMP_TIME_COVER)
{

    if(STATUS_COVER !=0) //already down or up then stop.
    {
        cover_stop(ID_COVER, STATUS_COVER, R_COVER_DOWN, R_COVER_UP, msg_COVER_STOP, msg_COVER_PERC, FULL_TIME_COVER, PREV_TIME_COVER, OFFSET_TIME_COVER, TEMP_TIME_COVER);
    }
    else
    { 
        if(Is_DOWN) //cover down
        { 
            digitalWrite(R_COVER_UP, RELAY_OFF);
            digitalWrite(R_COVER_DOWN, RELAY_ON);
            send(msg_COVER_DOWN.set(1));
            STATUS_COVER = 1; // DOWN 
            PREV_TIME_COVER = millis(); 
        }
        else //cover up 
        {
            digitalWrite(R_COVER_DOWN, RELAY_OFF);
            digitalWrite(R_COVER_UP, RELAY_ON);
            send(msg_COVER_UP.set(1));
            STATUS_COVER = 2; // UP 
            PREV_TIME_COVER = millis(); 
        } 
    }
}

bool initialValueSent = false;
//currentTime = millis();

void loop() 
{ 
    //Uruchomione raz do inicjalizacji dla HA
    if(!initialValueSent)
    {
        run_once(); 
        initialValueSent = true;
    }

    //***** P1_GOSCINNY_ROL1 *****//
    //DOWN
    if(BO_B_P1_GOSCINNY_ROL1_DOWN.update())
    {
        if(BO_B_P1_GOSCINNY_ROL1_DOWN.read() == LOW)
        {
            cover_down_up(ID_P1_GOSCINNY_ROL1, true, STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_DOWN, 
            msg_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC , FULL_TIME_P1_GOSCINNY_ROL1, PREV_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1); 
        }
    } 
    //UP
    if(BO_B_P1_GOSCINNY_ROL1_UP.update())
    {
        if(BO_B_P1_GOSCINNY_ROL1_UP.read() == LOW)
        {
            cover_down_up(ID_P1_GOSCINNY_ROL1, false, STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_DOWN, 
            msg_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC , FULL_TIME_P1_GOSCINNY_ROL1, PREV_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1); 
        }
    } 
    // Time check 
    time_to_stop(STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC, ID_P1_GOSCINNY_ROL1, PREV_TIME_P1_GOSCINNY_ROL1, FULL_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1);
    //_______________________________________

    //***** P1_OLAFA_ROL1 *****//
    //DOWN
    if(BO_B_P1_OLAFA_ROL1_DOWN.update())
    {
        if(BO_B_P1_OLAFA_ROL1_DOWN.read() == LOW)
        {
            cover_down_up(ID_P1_OLAFA_ROL1, true, STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_DOWN, 
            msg_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC , FULL_TIME_P1_OLAFA_ROL1, PREV_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1); 
        }
    } 
    //UP
    if(BO_B_P1_OLAFA_ROL1_UP.update())
    {
        if(BO_B_P1_OLAFA_ROL1_UP.read() == LOW)
        {
            cover_down_up(ID_P1_OLAFA_ROL1, false, STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_DOWN, 
            msg_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC , FULL_TIME_P1_OLAFA_ROL1, PREV_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1); 
        }
    } 
    // Time check 
    time_to_stop(STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC, ID_P1_OLAFA_ROL1, PREV_TIME_P1_OLAFA_ROL1, FULL_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1);
    //_______________________________________

    //***** P1_SYPIALNIA_ROL1 *****//
    //DOWN
    if(BO_B_P1_SYPIALNIA_ROL1_DOWN.update())
    {
        if(BO_B_P1_SYPIALNIA_ROL1_DOWN.read() == LOW)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL1, true, STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_DOWN, 
            msg_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC , FULL_TIME_P1_SYPIALNIA_ROL1, PREV_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1); 
        }
    } 
    //UP
    if(BO_B_P1_SYPIALNIA_ROL1_UP.update())
    {
        if(BO_B_P1_SYPIALNIA_ROL1_UP.read() == LOW)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL1, false, STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_DOWN, 
            msg_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC , FULL_TIME_P1_SYPIALNIA_ROL1, PREV_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1); 
        }
    } 
    // Time check 
    time_to_stop(STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC, ID_P1_SYPIALNIA_ROL1, PREV_TIME_P1_SYPIALNIA_ROL1, FULL_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1);
    //_______________________________________

        //***** P1_SYPIALNIA_ROL2 *****//
    //DOWN
    if(BO_B_P1_SYPIALNIA_ROL2_DOWN.update())
    {
        if(BO_B_P1_SYPIALNIA_ROL2_DOWN.read() == LOW)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL2, true, STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_DOWN, 
            msg_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC , FULL_TIME_P1_SYPIALNIA_ROL2, PREV_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2); 
        }
    } 
    //UP
    if(BO_B_P1_SYPIALNIA_ROL2_UP.update())
    {
        if(BO_B_P1_SYPIALNIA_ROL2_UP.read() == LOW)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL2, false, STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_DOWN, 
            msg_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC , FULL_TIME_P1_SYPIALNIA_ROL2, PREV_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2); 
        }
    } 
    // Time check 
    time_to_stop(STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC, ID_P1_SYPIALNIA_ROL2, PREV_TIME_P1_SYPIALNIA_ROL2, FULL_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2);
    //_______________________________________

    //***** P0_SALON_ROL1 *****//
    //DOWN
    if(BO_B_P0_SALON_ROL1_DOWN.update())
    {
        if(BO_B_P0_SALON_ROL1_DOWN.read() == LOW)
        {
            cover_down_up(ID_P0_SALON_ROL1, true, STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_DOWN, 
            msg_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC , FULL_TIME_P0_SALON_ROL1, PREV_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1); 
        }
    } 
    //UP
    if(BO_B_P0_SALON_ROL1_UP.update())
    {
        if(BO_B_P0_SALON_ROL1_UP.read() == LOW)
        {
            cover_down_up(ID_P0_SALON_ROL1, false, STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_DOWN, 
            msg_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC , FULL_TIME_P0_SALON_ROL1, PREV_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1); 
        }
    } 
    // Time check 
    time_to_stop(STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC, ID_P0_SALON_ROL1, PREV_TIME_P0_SALON_ROL1, FULL_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1);
    //_______________________________________

    //***** P0_SALON_ROL2 *****//
    //DOWN
    if(BO_B_P0_SALON_ROL2_DOWN.update())
    {
        if(BO_B_P0_SALON_ROL2_DOWN.read() == LOW)
        {
            cover_down_up(ID_P0_SALON_ROL2, true, STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_DOWN, 
            msg_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC , FULL_TIME_P0_SALON_ROL2, PREV_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2); 
        }
    } 
    //UP
    if(BO_B_P0_SALON_ROL2_UP.update())
    {
        if(BO_B_P0_SALON_ROL2_UP.read() == LOW)
        {
            cover_down_up(ID_P0_SALON_ROL2, false, STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_DOWN, 
            msg_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC , FULL_TIME_P0_SALON_ROL2, PREV_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2); 
        }
    } 
    // Time check 
    time_to_stop(STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC, ID_P0_SALON_ROL2, PREV_TIME_P0_SALON_ROL2, FULL_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2);
    //_______________________________________

    // ************************** SCHODOWE *************************************
    // Wiatrołap
    // #1_1
    if (BO_SCH_P0_WIATROLAP_1_1.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P0_WIATROLAP_1_1.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P0_WIATROLAP_1_1, !loadState(ID_SCH_P0_WIATROLAP_1_1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P0_WIATROLAP_1_1 + 1, loadState(ID_SCH_P0_WIATROLAP_1_1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P0_WIATROLAP, loadState(ID_SCH_P0_WIATROLAP_1_1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P0_WIATROLAP_1_1.set(loadState(ID_SCH_P0_WIATROLAP_1_1)));
      }
    }

    //#1_2
     if (BO_SCH_P0_WIATROLAP_1_2.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P0_WIATROLAP_1_2.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P0_WIATROLAP_1_1 + 1, !loadState(ID_SCH_P0_WIATROLAP_1_1 + 1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P0_WIATROLAP_1_1, loadState(ID_SCH_P0_WIATROLAP_1_1 + 1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P0_WIATROLAP, loadState(ID_SCH_P0_WIATROLAP_1_1 + 1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P0_WIATROLAP_1_1.set(loadState(ID_SCH_P0_WIATROLAP_1_1 + 1)));
          //send(msg_SCH_P0_WIATROLAP_1_2.set(loadState(ID_SCH_P0_WIATROLAP_1_1 +1)));
      }
    }
    // Korytarz parter
    // #1_1
    if (BO_SCH_P0_KORYTARZ_1_1.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P0_KORYTARZ_1_1.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P0_KORYTARZ_1_1, !loadState(ID_SCH_P0_KORYTARZ_1_1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P0_KORYTARZ_1_1 + 1, loadState(ID_SCH_P0_KORYTARZ_1_1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P0_KORYTARZ, loadState(ID_SCH_P0_KORYTARZ_1_1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P0_KORYTARZ_1_1.set(loadState(ID_SCH_P0_KORYTARZ_1_1)));
      }
    }

    //#1_2
     if (BO_SCH_P0_KORYTARZ_1_2.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P0_KORYTARZ_1_2.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P0_KORYTARZ_1_1 + 1, !loadState(ID_SCH_P0_KORYTARZ_1_1 + 1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P0_KORYTARZ_1_1, loadState(ID_SCH_P0_KORYTARZ_1_1 + 1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P0_KORYTARZ, loadState(ID_SCH_P0_KORYTARZ_1_1 + 1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P0_KORYTARZ_1_1.set(loadState(ID_SCH_P0_KORYTARZ_1_1 + 1)));
      }
    }
    // Schody
    // #1_1
    if (BO_SCH_SCHODY_1_1.update()) 
    {
      // Get the update value.
      int value = BO_SCH_SCHODY_1_1.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_SCHODY_1_1, !loadState(ID_SCH_SCHODY_1_1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_SCHODY_1_1 + 1, loadState(ID_SCH_SCHODY_1_1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_SCHODY, loadState(ID_SCH_SCHODY_1_1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_SCHODY_1_1.set(loadState(ID_SCH_SCHODY_1_1)));
      }
    }

    //#1_2
     if (BO_SCH_SCHODY_1_2.update()) 
    {
      // Get the update value.
      int value = BO_SCH_SCHODY_1_2.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_SCHODY_1_1 + 1, !loadState(ID_SCH_SCHODY_1_1 + 1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_SCHODY_1_1, loadState(ID_SCH_SCHODY_1_1 + 1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_SCHODY, loadState(ID_SCH_SCHODY_1_1 + 1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_SCHODY_1_1.set(loadState(ID_SCH_SCHODY_1_1 + 1)));
      }
    }
    // Korytarz piętro
    // #1_1
    if (BO_SCH_P1_KORYTARZ_1_1.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P1_KORYTARZ_1_1.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P1_KORYTARZ_1_1, !loadState(ID_SCH_P1_KORYTARZ_1_1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P1_KORYTARZ_1_1 + 1, loadState(ID_SCH_P1_KORYTARZ_1_1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P1_KORYTARZ, loadState(ID_SCH_P1_KORYTARZ_1_1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P1_KORYTARZ_1_1.set(loadState(ID_SCH_P1_KORYTARZ_1_1)));
      }
    }

    //#1_2
     if (BO_SCH_P1_KORYTARZ_1_2.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P1_KORYTARZ_1_2.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P1_KORYTARZ_1_1 + 1, !loadState(ID_SCH_P1_KORYTARZ_1_1 + 1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P1_KORYTARZ_1_1, loadState(ID_SCH_P1_KORYTARZ_1_1 + 1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P1_KORYTARZ, loadState(ID_SCH_P1_KORYTARZ_1_1 + 1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P1_KORYTARZ_1_1.set(loadState(ID_SCH_P1_KORYTARZ_1_1 + 1)));
      }
    }
    // Balkon Olafa + gościnny
    // #1_1
    if (BO_SCH_P1_BALKON_1_1.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P1_BALKON_1_1.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P1_BALKON_1_1, !loadState(ID_SCH_P1_BALKON_1_1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P1_BALKON_1_1 + 1, loadState(ID_SCH_P1_BALKON_1_1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P1_BALKON, loadState(ID_SCH_P1_BALKON_1_1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P1_BALKON_1_1.set(loadState(ID_SCH_P1_BALKON_1_1)));
      }
    }

    //#1_2
     if (BO_SCH_P1_BALKON_1_2.update()) 
    {
      // Get the update value.
      int value = BO_SCH_P1_BALKON_1_2.read();
      // Send in the new value.
      if(value == LOW)
      {
          
          saveState(ID_SCH_P1_BALKON_1_1 + 1, !loadState(ID_SCH_P1_BALKON_1_1 + 1));                        // zapisanie stanu przycisku 1_1
          saveState(ID_SCH_P1_BALKON_1_1, loadState(ID_SCH_P1_BALKON_1_1 + 1));                     // zapisanie identyczneog stanu dla przyciksu 1_2
          digitalWrite(R_SCH_P1_BALKON, loadState(ID_SCH_P1_BALKON_1_1 + 1)?RELAY_ON:RELAY_OFF);
          send(msg_SCH_P1_BALKON_1_1.set(loadState(ID_SCH_P1_BALKON_1_1 + 1)));
      }
    }

    // ************************** DZWONKOWE *************************************
    // DZWONEK
    
    if (BO_DZW_P0_DZWONEK.update()) 
    {
      // Get the update value.
      int value = BO_DZW_P0_DZWONEK.read();
      // Send in the new value.
      if(value == LOW)
      {
          //saveState(ID_DZW_P0_DZWONEK, !loadState(ID_DZW_P0_DZWONEK));                        // zapisanie stanu przycisku 1_1
          digitalWrite(R_DZW_P0_DZWONEK, RELAY_ON);
          send(msg_DZW_P0_DZWONEK.set(RELAY_ON));
      }
      else
      {
          digitalWrite(R_DZW_P0_DZWONEK, RELAY_OFF);
          send(msg_DZW_P0_DZWONEK.set(RELAY_OFF));
      }
    }
    
}
//main loop()

void receive(const MyMessage &message) 
{
// We only expect one type of message from controller. But we better check anyway.
// ACK for initial sent
    if (message.type == V_STATUS) 
    {
      if (!initialValueSent) 
      {
        initialValueSent = true;
      }
    }

    if (message.type==V_UP) 
    {
        //GOŚCINNY 
        if(message.sensor==ID_P1_GOSCINNY_ROL1)
        {
            cover_down_up(ID_P1_GOSCINNY_ROL1, false, STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_DOWN, 
            msg_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC , FULL_TIME_P1_GOSCINNY_ROL1, PREV_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1); 
        }

        //OLAFA 
        if(message.sensor==ID_P1_OLAFA_ROL1)
        {
            cover_down_up(ID_P1_OLAFA_ROL1, false, STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_DOWN, 
            msg_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC , FULL_TIME_P1_OLAFA_ROL1, PREV_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1); 
        }

        //SYPIALNIA ROL1 
        if(message.sensor==ID_P1_SYPIALNIA_ROL1)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL1, false, STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_DOWN, 
            msg_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC , FULL_TIME_P1_SYPIALNIA_ROL1, PREV_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1); 
        }

        //SYPIALNIA ROL2 
        if(message.sensor==ID_P1_SYPIALNIA_ROL2)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL2, false, STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_DOWN, 
            msg_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC , FULL_TIME_P1_SYPIALNIA_ROL2, PREV_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2); 
        }

        //SALON ROL1 
        if(message.sensor==ID_P0_SALON_ROL1)
        {
            cover_down_up(ID_P0_SALON_ROL1, false, STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_DOWN, 
            msg_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC , FULL_TIME_P0_SALON_ROL1, PREV_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1); 
        }

        //SALON ROL2 
        if(message.sensor==ID_P0_SALON_ROL2)
        {
            cover_down_up(ID_P0_SALON_ROL2, false, STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_DOWN, 
            msg_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC , FULL_TIME_P0_SALON_ROL2, PREV_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2); 
        }
    }

    if (message.type==V_DOWN) 
    {
        //GOŚCINNY 
        if(message.sensor==ID_P1_GOSCINNY_ROL1)
        {
            cover_down_up(ID_P1_GOSCINNY_ROL1, true, STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_DOWN, 
            msg_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC , FULL_TIME_P1_GOSCINNY_ROL1, PREV_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1); 
        } 

        //OLAFA 
        if(message.sensor==ID_P1_OLAFA_ROL1)
        {
            cover_down_up(ID_P1_OLAFA_ROL1, true, STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_DOWN, 
             msg_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC , FULL_TIME_P1_OLAFA_ROL1, PREV_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1); 
        } 

        //SYPIALNIA ROL1 
        if(message.sensor==ID_P1_SYPIALNIA_ROL1)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL1, true, STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_DOWN, 
             msg_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC , FULL_TIME_P1_SYPIALNIA_ROL1, PREV_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1); 
        }

        //SYPIALNIA ROL2 
        if(message.sensor==ID_P1_SYPIALNIA_ROL2)
        {
            cover_down_up(ID_P1_SYPIALNIA_ROL2, true, STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_DOWN, 
             msg_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC , FULL_TIME_P1_SYPIALNIA_ROL2, PREV_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2); 
        }
        
        //SALON ROL1 
        if(message.sensor==ID_P0_SALON_ROL1)
        {
            cover_down_up(ID_P0_SALON_ROL1, true, STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_DOWN, 
             msg_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC , FULL_TIME_P0_SALON_ROL1, PREV_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1); 
        }

        //SALON ROL2 
        if(message.sensor==ID_P0_SALON_ROL2)
        {
            cover_down_up(ID_P0_SALON_ROL2, true, STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_DOWN, 
             msg_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC , FULL_TIME_P0_SALON_ROL2, PREV_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2); 
        }
    }

    if (message.type==V_STOP) 
    {

        //GOŚCINNY  
        if(message.sensor==ID_P1_GOSCINNY_ROL1)
        {
            cover_stop(ID_P1_GOSCINNY_ROL1, STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC, FULL_TIME_P1_GOSCINNY_ROL1, 
            PREV_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1);
        } 

        //OLAFA
        if(message.sensor==ID_P1_OLAFA_ROL1)
        {
    
            cover_stop(ID_P1_OLAFA_ROL1, STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC, FULL_TIME_P1_OLAFA_ROL1, 
            PREV_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1);
        } 

        //SYPIALNIA ROL1
        if(message.sensor==ID_P1_SYPIALNIA_ROL1)
        {
    
            cover_stop(ID_P1_SYPIALNIA_ROL1, STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC, FULL_TIME_P1_SYPIALNIA_ROL1, 
            PREV_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1);
        } 

        //SYPIALNIA ROL2
        if(message.sensor==ID_P1_SYPIALNIA_ROL2)
        {
    
            cover_stop(ID_P1_SYPIALNIA_ROL2, STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC, FULL_TIME_P1_SYPIALNIA_ROL2, 
            PREV_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2);
        } 
        
        //SALON ROL1
        if(message.sensor==ID_P0_SALON_ROL1)
        {
    
            cover_stop(ID_P0_SALON_ROL1, STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC, FULL_TIME_P0_SALON_ROL1, 
            PREV_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1);
        } 

        //SALON ROL2
        if(message.sensor==ID_P0_SALON_ROL2)
        {
    
            cover_stop(ID_P0_SALON_ROL2, STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC, FULL_TIME_P0_SALON_ROL2, 
            PREV_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2);
        } 
    }

    if (message.type==V_PERCENTAGE) 
    {
        //GOŚCINNY
        if(message.sensor==ID_P1_GOSCINNY_ROL1)
        {
            cover_perc_down_up(ID_P1_GOSCINNY_ROL1, STATUS_P1_GOSCINNY_ROL1, R_P1_GOSCINNY_ROL1_DOWN, R_P1_GOSCINNY_ROL1_UP, msg_P1_GOSCINNY_ROL1_DOWN, msg_P1_GOSCINNY_ROL1_UP, 
            msg_P1_GOSCINNY_ROL1_STOP, msg_P1_GOSCINNY_ROL1_PERC, message.getByte(), FULL_TIME_P1_GOSCINNY_ROL1, PREV_TIME_P1_GOSCINNY_ROL1, OFFSET_TIME_P1_GOSCINNY_ROL1, TEMP_TIME_P1_GOSCINNY_ROL1);
        }
        //OLAFA
        if(message.sensor==ID_P1_OLAFA_ROL1)
        {
            cover_perc_down_up(ID_P1_OLAFA_ROL1, STATUS_P1_OLAFA_ROL1, R_P1_OLAFA_ROL1_DOWN, R_P1_OLAFA_ROL1_UP, msg_P1_OLAFA_ROL1_DOWN, msg_P1_OLAFA_ROL1_UP, 
            msg_P1_OLAFA_ROL1_STOP, msg_P1_OLAFA_ROL1_PERC, message.getByte(), FULL_TIME_P1_OLAFA_ROL1, PREV_TIME_P1_OLAFA_ROL1, OFFSET_TIME_P1_OLAFA_ROL1, TEMP_TIME_P1_OLAFA_ROL1);
        }
        //SYPIALNIA ROL1
        if(message.sensor==ID_P1_SYPIALNIA_ROL1)
        {
            cover_perc_down_up(ID_P1_SYPIALNIA_ROL1, STATUS_P1_SYPIALNIA_ROL1, R_P1_SYPIALNIA_ROL1_DOWN, R_P1_SYPIALNIA_ROL1_UP, msg_P1_SYPIALNIA_ROL1_DOWN, msg_P1_SYPIALNIA_ROL1_UP, 
            msg_P1_SYPIALNIA_ROL1_STOP, msg_P1_SYPIALNIA_ROL1_PERC, message.getByte(), FULL_TIME_P1_SYPIALNIA_ROL1, PREV_TIME_P1_SYPIALNIA_ROL1, OFFSET_TIME_P1_SYPIALNIA_ROL1, TEMP_TIME_P1_SYPIALNIA_ROL1);
        }
        //SYPIALNIA ROL2
        if(message.sensor==ID_P1_SYPIALNIA_ROL2)
        {
            cover_perc_down_up(ID_P1_SYPIALNIA_ROL2, STATUS_P1_SYPIALNIA_ROL2, R_P1_SYPIALNIA_ROL2_DOWN, R_P1_SYPIALNIA_ROL2_UP, msg_P1_SYPIALNIA_ROL2_DOWN, msg_P1_SYPIALNIA_ROL2_UP, 
            msg_P1_SYPIALNIA_ROL2_STOP, msg_P1_SYPIALNIA_ROL2_PERC, message.getByte(), FULL_TIME_P1_SYPIALNIA_ROL2, PREV_TIME_P1_SYPIALNIA_ROL2, OFFSET_TIME_P1_SYPIALNIA_ROL2, TEMP_TIME_P1_SYPIALNIA_ROL2);
        }
        //SALON ROL1
        if(message.sensor==ID_P0_SALON_ROL1)
        {
            cover_perc_down_up(ID_P0_SALON_ROL1, STATUS_P0_SALON_ROL1, R_P0_SALON_ROL1_DOWN, R_P0_SALON_ROL1_UP, msg_P0_SALON_ROL1_DOWN, msg_P0_SALON_ROL1_UP, 
            msg_P0_SALON_ROL1_STOP, msg_P0_SALON_ROL1_PERC, message.getByte(), FULL_TIME_P0_SALON_ROL1, PREV_TIME_P0_SALON_ROL1, OFFSET_TIME_P0_SALON_ROL1, TEMP_TIME_P0_SALON_ROL1);
        }
        //SALON ROL2
        if(message.sensor==ID_P0_SALON_ROL2)
        {
            cover_perc_down_up(ID_P0_SALON_ROL2, STATUS_P0_SALON_ROL2, R_P0_SALON_ROL2_DOWN, R_P0_SALON_ROL2_UP, msg_P0_SALON_ROL2_DOWN, msg_P0_SALON_ROL2_UP, 
            msg_P0_SALON_ROL2_STOP, msg_P0_SALON_ROL2_PERC, message.getByte(), FULL_TIME_P0_SALON_ROL2, PREV_TIME_P0_SALON_ROL2, OFFSET_TIME_P0_SALON_ROL2, TEMP_TIME_P0_SALON_ROL2);
        }
    } 

     // **************** SCHODOWE ************************

     if (message.type==V_LIGHT) 
     {
        // Change relay state
        //digitalWrite(R_SCH_P0_WIATROLAP, message.getBool()?RELAY_ON:RELAY_OFF);     
        // Store state in eeprom
        //saveState(message.sensor, message.getBool());

          // Wiatrołap
          if (message.sensor == ID_SCH_P0_WIATROLAP_1_1)
          {
            digitalWrite(R_SCH_P0_WIATROLAP, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor + 1, message.getBool());
            
          }

          if (message.sensor == ID_SCH_P0_WIATROLAP_1_2)
          {
            digitalWrite(R_SCH_P0_WIATROLAP, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor - 1, message.getBool());
          }

          // Korytarz parter
          if (message.sensor == ID_SCH_P0_KORYTARZ_1_1)
          {
            digitalWrite(R_SCH_P0_KORYTARZ, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor + 1, message.getBool());
          }

          if (message.sensor == ID_SCH_P0_KORYTARZ_1_2)
          {
            digitalWrite(R_SCH_P0_KORYTARZ, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor - 1, message.getBool());
          }

          // Schody
          if (message.sensor == ID_SCH_SCHODY_1_1)
          {
            digitalWrite(R_SCH_SCHODY, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor + 1, message.getBool());
          }

          if (message.sensor == ID_SCH_SCHODY_1_2)
          {
            digitalWrite(R_SCH_SCHODY, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor - 1, message.getBool());
          }

          // Korytarz piętro
          if (message.sensor == ID_SCH_P1_KORYTARZ_1_1)
          {
            digitalWrite(R_SCH_P1_KORYTARZ, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor + 1, message.getBool());
          }

          if (message.sensor == ID_SCH_P1_KORYTARZ_1_2)
          {
            digitalWrite(R_SCH_P1_KORYTARZ, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor - 1, message.getBool());
          }

          // Balkon Olafa + gościnny
          if (message.sensor == ID_SCH_P1_BALKON_1_1)
          {
            digitalWrite(R_SCH_P1_BALKON, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor + 1, message.getBool());
          }

          if (message.sensor == ID_SCH_P1_BALKON_1_2)
          {
            digitalWrite(R_SCH_P1_BALKON, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            saveState(message.sensor, message.getBool());
            saveState(message.sensor - 1, message.getBool());
          }
          
          //************************** DZWONKOWE ***********************
          // DZWONEK

          if (message.sensor == ID_DZW_P0_DZWONEK)
          {
            digitalWrite(R_DZW_P0_DZWONEK, message.getBool()?RELAY_ON:RELAY_OFF);     
            // Store state in eeprom
            //saveState(message.sensor, message.getBool());
          }
          
          
     
        // Write some debug info
        Serial.print("Incoming change for sensor:");
        Serial.print(message.sensor);
        Serial.print(", New status: ");
        Serial.println(message.getBool());
     }
}
